function UnselectCredList()
{
  var Listbox = document.getElementById("CredListbox");
  Listbox.selectedIndex = -1;
}


function OnCredParamChanged ()
{
  UnselectNetList();
  OnNetModified ();
}


function OnNetModified ()
{
  var Listbox   = document.getElementById("CredListbox");
  var Entry     = GetCredString ();
  var bExists   = true;

  if ( Listbox )
  {
    if ( Entry.length > 0 && tbListboxContainsText (Listbox, Entry) == false )
      bExists = false;
    else
    {
      bExists = true;

      for ( var i = 0; i < Listbox.length; i++ )
      {
        if ( Listbox.options[i] && Listbox.options[i].text == Entry )
        {
          Listbox.selectedIndex = i;
          break;
        }
      }
    }

    g_ModifiedSourceId = GetSelectedSourceId();
  }

  tbEnableButton ( "CredAddButton", bExists == false );
  tbEnableButton ( "CredRemoveButton", Listbox.selectedIndex != -1 );
}


function GetCredString ()
{
  var SecurityName  = tbGetValue ( "CredSecurityName" );
  var AuthProtocol  = tbGetValue ( "CredAuthProtocol" );
  var AuthPassword  = tbGetValue ( "CredAuthPassword" );
  var PrivProtocol  = tbGetValue ( "CredPrivProtocol" );
  var PrivPassword  = tbGetValue ( "CredPrivPassword" );
  var ContextName   = tbGetValue ( "CredContextName" );
  var Entry         = SecurityName + ' : ';

  Entry += AuthProtocol + ', ';
  Entry += PrivProtocol + ', ';
  Entry += ContextName;

  return Entry;
}


function OnNetAddButtonClick ()
{
  var Listbox      = document.getElementById("CredListbox");
  var Entry        = GetCredString ();
  var AuthPassword = tbGetValue ( "AuthPassword" );
  var PrivPassword = tbGetValue ( "PrivPassword" );

  for ( var i = 0; i < Listbox.length; i++ )
    Listbox.options[i].selected = false;

  myOption = new Option ( Entry, Listbox.length + 1, false, true );
  Listbox.appendChild ( myOption );

  myOption.setAttribute('data-authpassword', AuthPassword);
  myOption.setAttribute('data-privpassword', PrivPassword);
}


function OnNetRemoveButtonClick ()
{
  g_ModifiedSourceId = GetSelectedSourceId ();

  tbListboxRemoveSelected ( document.getElementById("CredListbox") );
  OnNetListChange();
}


function OnNetListChange()
{
  var List  = document.getElementById('CredListbox');
  var Entry = List[List.selectedIndex];
  var Line  = Entry ? Entry.innerHTML : '';

  if ( Entry && Line != '' )
  {
    var Strings      = Line.split (' : ');
    var SecurityName = Strings[0];

    var Params       = Strings[1].split(', ');
    var AuthPassword = Entry.dataset.authpassword;
    var PrivPassword = Entry.dataset.privpassword;

    document.getElementById('CredSecurityName').value = SecurityName;
    document.getElementById('AuthProtocol').value = Params[0];
    document.getElementById('CredAuthPassword').value = AuthPassword;
    document.getElementById('CredPrivProtocol').value = Params[1];
    document.getElementById('CredPrivPassword').value = PrivPassword;
    document.getElementById('CredContextName').value = Params[2];
  }

  tbEnableButton ( 'CredRemoveButton', Line != '' );
}
